﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using com.mf.demo.CryRpt;

namespace CsharpWeb
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {


        }

        protected void lstChanged(object sender, EventArgs e)
        {
            //COBOL のクラスをインスタンス化
            CobFileHandle cobf = new CobFileHandle();
            //CeateCobFile メソッドを呼び出し、選択された注文番号に応じた COBOL ファイルを生成
            cobf.CreateCobFile(Int32.Parse(lstOrderID.SelectedValue.ToString()));

            ReportDocument rptDoc = new ReportDocument(); //CrystalReports の ReportDocument をインスタンス化
            DS_By_Order_ID ds = new DS_By_Order_ID();     //CrystalReports に紐つく DataSet をインスタンス化
            //DataTable を作成
            DataTable dt = new DataTable();
            createDT(ref dt);

            //ReadCobFile メソッドを呼び出し、COBOL ファイルから読み込んだデータを DataTable にセット
            cobf.ReadCobFile(ref dt);
                   
            ds.Tables[0].Merge(dt);  //DataSet に上で作成した DataTable をセット

            rptDoc.Load(Server.MapPath("/CR_By_Order_ID.rpt")); //CR_By_Order_ID.rpt をロード
            rptDoc.SetDataSource(ds);                           //DataSet を ReportDocuments にセット
            CrystalReportViewer1.ReportSource = rptDoc;         //ページ中の CrystalReportViewer1 オブジェクトのソースに ReportDocument オブジェクトをセット
        }

        //DS_By_Order_ID の DataTable1 と同じ構成の DataTable を作成
        private void createDT(ref DataTable dt)
        {
            dt.TableName = "Crystal Reports Sample Tbl";

            DataColumn wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.String");
            wkCol.ColumnName = "Product_Name";
            dt.Columns.Add(wkCol);

            wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.String");
            wkCol.ColumnName = "P_Cat_Name";
            dt.Columns.Add(wkCol);

            wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.String");
            wkCol.ColumnName = "Company_Name";
            dt.Columns.Add(wkCol);

            wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.Int16");
            wkCol.ColumnName = "Order_Qty";
            dt.Columns.Add(wkCol);

            wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.Decimal");
            wkCol.ColumnName = "Unit_Price";
            dt.Columns.Add(wkCol);

            wkCol = new DataColumn();
            wkCol.DataType = System.Type.GetType("System.Decimal");
            wkCol.ColumnName = "Line_Total";
            dt.Columns.Add(wkCol);
        }
    }

    
}
